<?php
/*
Plugin Name: WP-ImgCode mod
Plugin URI: http://www.chweng.idv.tw/blog/wordpress/wp-imgcode-mod/
Description: Add secure code to your comment form to avoid spam bots leaving trash messages on your site. Originally written by <a href="http://www.dualface.com/blog/?p=194">dualface</a>.
Version: 0.1
Author: C.H.Weng
Author URI: http://www.chweng.idv.tw/
*/

$plugin_dir = get_bloginfo('wpurl').'/wp-content/plugins/wp-imgcode';

@session_start();
add_action('comment_form','show_code');
add_action('get_footer',"give_js_of_tas");
add_filter('preprocess_comment','verify_code');

function show_code() {
	global $user_ID;
	global $plugin_dir;
	if (empty($user_ID)) {
        $hiddencode = md5(microtime().$_SERVER['REQUEST_URI']);
		echo '<p><input type="text" name="imgcode" id="imgcode" style="width:40px" maxlength="4" /> <label for="imgcode" style="color:#ff0000">验证码</label> <img alt="换验证码请刷新页面" src="'.$plugin_dir.'/imgcode.php?hiddencode='.$hiddencode.'" style="border:0" /></p>';
        echo '<input type="hidden" name="hiddencode" value="'.$hiddencode.'" />';
	}
}

function verify_code($commentdata) {
	global $user_ID,$comment_type;
        $hiddencode = $_POST['hiddencode'];
	if ((empty($user_ID) && $comment_type=='') && (($_POST['imgcode'] != $_SESSION['IMGCODE'.$hiddencode]) || time() >= $_SESSION['IMGCODE_EXPIRED'.$hiddencode])) {
		unset($_SESSION['IMGCODE'.$hiddencode]);
		unset($_SESSION['IMGCODE_EXPIRED'.$hiddencode]);
		wp_die(__('验证码错误或过期,请返回重填'));
	}
	return $commentdata;
}

function give_js_of_tas() {
?>
<script type="text/javascript">
function seccodeEntered(){
  if (document.getElementById('imgcode').value.length==4){
	return true;
  } else {
	alert("据可靠消息称你没有填写验证码,麻烦填写一下,谢谢！Spam太多了,我实属不得已,对不起诸位了.");
	return false;  
  }
}

var commentform = document.getElementById("commentform");
if (commentform != null) {
  commentform.setAttribute("onSubmit","return seccodeEntered();");
}
</script>
<?php
}
?>